function expected_age_penalties_lut = expected_penalty_lognormal(age_penalty_lut, samples, z, parameters)
    [sample_size, samples_Normal, a, mu, sigma, y_shift] = parameters{:};
    mean_tmp = exp(mu+sigma^2/2);
    
    randn('seed',10);
    sample_normal_next = randn(1,sample_size);
    
    %Monte Carlo Method - generate sample_size samples with distribution
    samples_Y_ = exp(mplus(a*samples_Normal, sqrt(1-a^2)*sample_normal_next).*sigma + mu)/mean_tmp;
    samples_Y_ = round(samples_Y_)+y_shift;

    age_penalties = zeros(length(samples), size(samples_Y_, 2));
    for j = 1:size(samples_Y_, 2)
        indices = min(samples+z+samples_Y_(:,j)+1, length(age_penalty_lut)); % ONE INDEXED!!!!!!!!!
        age_penalties(:,j) = age_penalty_lut(indices)';
    end
    expected_age_penalties_lut = mean(age_penalties, 2); %E[p(n+Yi+1-Si)]
end

