ND = 10; %digit right of decimal when two numbers are "equal"
fudge_factor = 1e-6; %Fudge factor because > in floating point is difficult

times = 40; %times to run bisection search
max_z = 100; %Maximum delay considered

%beta can be negative (for negative increasing penalty functions) or positive (for
%positive decreasing penalty functions)
if age_penalty_lut(2) < 0
    beta_low = -10;
    beta_high = 0;
else
    beta_low = 0;
    beta_high = 10;
end
beta = (beta_low+ beta_high)/2;

%Bisection Search to get the optimal beta
for index=1:times   
    wait_times_optimal = zeros(1, sample_num);
    flags_set = zeros(sample_num, 1);
    %Count up through "n" (n = Y_i+Z) until you hit the threshold.
    for z = 0:max_z
        %Get all possible penalties for given distribution of Yi+1. 
        expected_penalty = feval(fname_expected_penalty, age_penalty_lut, samples(1:sample_num), z, parameters);
        flags_beta = expected_penalty >= beta;
        wait_times_optimal(flags_beta & ~flags_set) = z;
        flags_set = flags_set | flags_beta;
        if all(flags_set)
            break;
        end
    end
    
    expected_time = mean(wait_times_optimal)+mean_; %E[D_i+1-D_i] = E[Z+Yi+1]
    %Bisection Search of Beta

    expected_penalty_sum = feval(fname_expected_sum, expected_sum_lut, samples(1:sample_num), wait_times_optimal, parameters);
    
    %beta can be negative (for negative increasing penalty functions) or positive (for
    %positive increasing penalty functions)
    if beta < 0 && expected_time >= expected_penalty_sum/beta %|| expected_time < T
        beta_low = beta;
    elseif beta > 0 && expected_time < expected_penalty_sum/beta
        beta_low = beta;
    else
        beta_high = beta;
    end
    beta = (beta_low+ beta_high)/2;

    if round(beta_low, ND) == round(beta_high, ND)
        break;
    end
end

%If under f_max Constraint
if expected_time < T    %Constraint  
    beta_low = -10;
    beta_high = 0;
    beta = (beta_low+ beta_high)/2;
    times = 100; 

    max_z = 1000;
    %Bisection Search to get the optimal beta
    for index=1:times   
        wait_times_Tmin = zeros(1, sample_num);
        wait_times_Tmax = zeros(1, sample_num);
        flags_set_Tmin = zeros(sample_num, 1);
        flags_set_Tmax = zeros(sample_num, 1);
        %Count up through "n" (n = Y_i+Z) until you hit the threshold.
        for z = 0:max_z
            %Get all possible penalties for given distribution of Yi+1. 
            expected_penalty = feval(fname_expected_penalty, age_penalty_lut, samples(1:sample_num), z, parameters);
            flags_Tmin = expected_penalty >= beta;
            flags_Tmax = expected_penalty > beta+fudge_factor;
            wait_times_Tmin(flags_Tmin & ~flags_set_Tmin) = z;
            wait_times_Tmax(flags_Tmax & ~flags_set_Tmax) = z;
            flags_set_Tmin = flags_set_Tmin | flags_Tmin;
            flags_set_Tmax = flags_set_Tmax | flags_Tmax;
            if all(flags_set_Tmin & flags_set_Tmax)
                break;
            end
        end

        expected_time_Tmin = mean(wait_times_Tmin)+mean_; %E[D_i+1-D_i] = E[Z+Yi+1]
        expected_time_Tmax = mean(wait_times_Tmax)+mean_; %E[D_i+1-D_i] = E[Z+Yi+1]

        expected_penalty_sum = feval(fname_expected_sum, expected_sum_lut, samples(1:sample_num), wait_times_Tmin, parameters);

        if expected_time_Tmin < T
            beta_low = beta;
        else
            beta_high = beta;
        end
        beta = (beta_low+ beta_high)/2;

        if round(beta_low, ND) == round(beta_high, ND) && expected_time_Tmin < T
            break;
        end
    end
    
    %Set wait time with optimal probability
    T_min = expected_time_Tmin;
    T_max = expected_time_Tmax;

    if T_max == T_min
        lambda = 0;
    else
        lambda = (T_max - T)/(T_max - T_min);
    end
    
    random = rand(sample_num, 1);
    
    indices = random < lambda;
    wait_times_optimal(indices) = max(0, wait_times_Tmin(indices));
    wait_times_optimal(~indices) = max(0, wait_times_Tmax(~indices));

    expected_time = mean(wait_times_optimal)+mean_;
end
